# SpiralMap 
A Python library of the Milky Way's spiral arms. 

[![pypi status](https://img.shields.io/pypi/v/spiralmap.svg?logo=pypi&logoColor=white&label=PyPI)](https://pypi.org/project/SpiralMap/)
[![Documentation Status](https://app.readthedocs.org/projects/spiralmap/badge/?version=latest)](https://spiralmap.readthedocs.io/en/latest/?badge=latest)

The detailed documentation is hosted on [Read the docs](https://spiralmap.readthedocs.io/en/latest/#api-docs).

For a quickstart please refer to the accompanying [Jupyter notebook](https://github.com/Abhaypru/SpiralMap/blob/main/demo_spiralmap.ipynb)

## Features
+ Access 8 independent spiral arm models from literature. We are open to requests for including other spiral arm models. 
+ Extract the 2D trace of individual or all spiral arms from a particular model.
+ Directly overplot spiral arms with choice of Cartesian or Polar coordinates, and in Heliocentric or Galactocentric frames.


Installation
-------------

Install the latest released version using ``pip``:

```
   pip install SpiralMap
```

Acknowledging ``SpiralMap``
---------------------------------------
If you make use of our package, please cite the accompanying paper. 

Additionally, please also cite the individual spiral model used. To facilitate this, we provide a BibTex file with the relevant citations in 'datafiles/spiral.bib' (on GitHub),
or alternatively these are also available on [Read the docs](https://spiralmap.readthedocs.io/en/latest/#api-docs).

